<?xml version="1.0"?>
<!-- This file is protected by Copyright. Please refer to the COPYRIGHT file
     distributed with this source distribution.

     This file is part of OpenCPI <http://www.opencpi.org>

     OpenCPI is free software: you can redistribute it and/or modify it under
     the terms of the GNU Lesser General Public License as published by the Free
     Software Foundation, either version 3 of the License, or (at your option)
     any later version.

     OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
     WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
     more details.

     You should have received a copy of the GNU Lesser General Public License
     along with this program. If not, see <http://www.gnu.org/licenses/>. -->
<componentspec>
  <property name="rounding_type" type="enum" parameter="true" enums="truncate,half_up,half_even" default="half_even"
    description="Selects the sample rounding type"/>
  <property name="max_number_of_taps" type="ushort" parameter="true" default="64"
    description="Defines the maximum number of taps across all interpolation branches"/>
  <property name="interpolation_factor" type="uchar" initial="true" writable="false" default="8"
    description="Defines the number of branches that can be used for interpolation"/>
  <property name="number_of_taps" type="ushort" initial="true" writable="false" default="max_number_of_taps"
    description="Number of taps that are actually being used per interpolation branch"/>
  <!-- LINT EXCEPTION: xml_012: 2:
       Cannot set default as size varies with parameter values. -->
  <property name="taps" type="short" arraylength="max_number_of_taps" writable="true" description="Polyphase interpolation taps"/>
  <property name="loop_coefficients" arraylength="3" type="short" writable="true" default="1536,51,512"
    description="Coefficients for the loop filter and NCO"/>
  <port name="input" producer="false" protocol="complex_short_timed_sample-prot"/>
  <port name="output" producer="true" protocol="complex_short_timed_sample-prot"/>
</componentspec>
